
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>大前端开发者需要了解的基础编译原理和语言知识 / iVAN</title>

    <meta name="description" content="大前端开发者需要了解的基础编译原理和语言知识 在我刚刚进入大学,从零开始学习 C 语言的时候,我就不断的从学长的口中听到一个又一个语言,比如 C++.Java.Python.JavaScript 这些大众的,也有 Lisp.Perl.Ruby 这些相对小众的.一般来说,当程序员讨论一门语言的时候,默认的上下文经常是:&quot;用 xxx 语言来完成 xxx 任务&quot;.所以一直困扰着的我的一个问题就是,为什么完成某个任务,一定要选择特定的语言,比如安卓开发是 Java,前端要用 JavaScript,iOS 开发使用 Objecti ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">大前端开发者需要了解的基础编译原理和语言知识</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在我刚刚进入大学，从零开始学习 C 语言的时候，我就不断的从学长的口中听到一个又一个语言，比如<br />
C++、Java、Python、JavaScript  这些大众的，也有 Lisp、Perl、Ruby<br />
这些相对小众的。一般来说，当程序员讨论一门语言的时候，默认的上下文经常是:“用 xxx 语言来完成 xxx<br />
任务”。所以一直困扰着的我的一个问题就是，为什么完成某个任务，一定要选择特定的语言，比如安卓开发是 Java，前端要用<br />
JavaScript，iOS 开发使用  Objective-C 或者<br />
Swift。这些问题的答案非常复杂，有的是技术原因，有的是历史原因，有的会考虑成本，很难得出统一的结论，只能  case-by-case<br />
的分析。这篇文章并非专门解答上述问题，而是希望通过介绍一些通用的概念，帮助读者掌握分析问题的能力，如果这个概念在实际编程中用得到，我也会举一些具体的例子。</p>
<p>在阅读本文前，不妨思考一下这几个问题，如果没有头绪，建议看完文章以后再思考一遍。如果觉得答案显而易见，恭喜你，这篇文章并非为你准备的:</p>
<ol>
<li>什么是编译器，它以什么为分界线，分为前端和后端?</li>
<li>Java 是编译型语言还是解释型语言，Python 呢?</li>
<li>C 语言的编译器也是 C 语言，那它怎么被编译的?</li>
<li>目标文件的格式是什么样的，段表、符号表、重定位表有什么作用?</li>
<li>Swift 是静态语言，为什么还有运行时库?</li>
<li>什么是 ABI，ABI 不稳定有什么问题?</li>
<li>什么是 WebAssembly，为什么要推出这门技术，用 C++ 代替 JavaScript 可行么?</li>
<li>JavaScript 和 DOM API 是什么关系，JavaScript 可以读写文件么?</li>
<li>C++ 代码可以自动转换成 Java 代码么，任意两种语言是否可以互转?</li>
<li>为什么说 Python 是胶水语言，它可以用来开发 iOS/Android 么?</li>
</ol>
<p><strong>编译原理</strong></p>
<p>就像数学是一个公理体系，从简单的公理就能推导出各种高阶公式一样，我们从最基本的 C 语言和编译说起。</p>
<pre>
</pre>
<ol>
<li>int main(void) { </li>
<li>    int a = strlen("Hello world");  // 字符串的长度是 11 </li>
<li>    return 0; </li>
<li>} </li>
</ol>
<p>相关的介绍编译过程的文章很多，读者应该都非常熟悉了，整个流程包括预处理、词法分析、语法分析、生成中间代码，生成目标代码，汇编，链接<br />
等。已有的文章大多分析了每一步的逻辑，但很少谈实现思路，我会尽量用简单的语言来描述每一步的实现思路，相信这样有助于加深记忆。由于主要谈的概念和思路，难免会有一些不够准确的抽象，读者学会抓重点就行。</p>
<p>预处理是一个独立的模块，它放在最后介绍，我们先看词法分析。</p>
<p><strong>词法分析</strong></p>
<p>最先登场的是编译器，它负责前五个步骤，也就是说编译器的输入是源代码，输出是中间代码。</p>
<p>编译器不能像人一样，一眼就看明白源代码的内容，它只能比较傻的逐个单词分析。词法分析要做的就是把源代码分割开，形成若干个单词。这个过程并不像想象的那么简单。比如举几个例子:</p>
<ol>
<li>int t 表示一个整数，而 intt 只是一个变量名。</li>
<li>int a() 表示一个函数而非整数 a，int a () 也是一个函数。</li>
<li>a = 没有具体价值，它可以是一个赋值语句，还可以是 a == 1 的前缀，表示一个判断。</li>
</ol>
<p>词法分析的主要难点在于，前缀无法决定一个完整字符串的含义，通常需要看完整句以后才知道每个单词的具体含义。同时，C  语言的语法也不简单，各种关键字，括号，逗号，语法等等都会给词法分析的实现增加难度。</p>
<p>词法分析的主要实现原理是状态机，它逐个读取字符，然后根据读到的字符的特点转换状态。比如这是 GCC 的词法分析状态机(引用自《编译系统透视》):  </p>
<p><a href="http://s2.51cto.com/wyfs02/M00/9A/0C/wKiom1lQtU-zq0tWAADX2leY1vU902.jpg-wh_651x-s_3551572978.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOUEvMEMvd0tpb20xbFF0VS16cTB0V0FBRFgybGVZMXZVOTAyLmpwZy13aF82NTF4LXNfMzU1MTU3Mjk3OC5qcGc=.jpg"></a></p>
<p>如果自己实现的话，思路也不难。外面包一个循环，然后各种 switch...case 就完事了。词法分析应该算是最简单的一节。</p>
<p><strong>语法分析</strong></p>
<p>经过词法分析以后，编译器已经知道了每个单词，但这些单词组合起来表示的语法还不清楚。一个简单的思路是模板匹配，比如有这样的语句:</p>
<pre>
</pre>
<ol>
<li>int a = 10; </li>
</ol>
<p>它其实表示了这么一种通用的语法格式:</p>
<p>类型 变量名 = 常量;</p>
<p>所以 int a = 10; 当然可以匹配上这种模式。同理，它不可能匹配 类型 函数名(参数);  这种函数定义模式，因为两者结构不一致，等号无法被匹配。</p>
<p>语法分析比词法分析更复杂，因为所有 C 语言支持的语法特性都必须被语法分析器正确的匹配，这个难度比纯新手学习 C  语言语法难上很多倍。不过这个属于业务复杂性，无论采用哪种解决方案都不可避免，因为语法规则的数量就是这么多。</p>
<p>在匹配模式的时候，另一个问题在于上述的名词，比如 类型、参数，很难界定。比如int 是类型，long long 也是类型，unsigned<br />
 long  long 也是类型。(int a) 可以是参数，(int a, int b) 也是参数，(unsigned long long<br />
a, long long  double b, int *p) 看起来能把人逼疯。</p>
<p>下面举一个简单的例子来解释 int a = 10<br />
是如何被解析的，总的思路是归纳与分解。我们把一个复杂的式子分割成若干部分，然后分析各个部分，这样可以简化复杂度。对于 int a = 10<br />
来说，他是一个声明，声明由两部分组成，分别是声明说明符和初始声明符列表。</p>
<table>
<thead>
<tr>
<th>声明</th>
<th>声明说明符</th>
<th>初始声明符列表</th>
</tr>
</thead>
<tbody>
<tr>
<td>int a = 10</td>
<td>int</td>
<td>a = 10</td>
</tr>
<tr>
<td>int fun(int a)</td>
<td>int</td>
<td>fun(int a)</td>
</tr>
<tr>
<td>int array[5]</td>
<td>int</td>
<td>array[5]</td>
</tr>
</tbody>
</table>
<p>声明说明符比较简单，它其实是若干个类型的串联:</p>
<p>声明说明符 = 类型 + 类型的数组(长度可以为 0)</p>
<p>而且我们知道若干个类型连在一起又变成了声明说明符，所以上述等式等价于:</p>
<p>声明说明符 = 类型 + 声明说明符(可选)</p>
<p>再严谨一些，声明说明符还可以包括 const 这样的限定说明符，inline 这样的函数说明符，和 _Alignas  这样的对齐说明符。借用书中的公式，它的完整表达如下:</p>
<p><a href="http://s3.51cto.com/wyfs02/M00/9A/0C/wKioL1lQtZ_wMNxIAABA3jF_7HI733.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOUEvMEMvd0tpb0wxbFF0Wl93TU54SUFBQkEzakZfN0hJNzMzLmpwZw==.jpg"></a></p>
<p>这才仅仅是声明语句中最简单的声明说明符，仅仅是几个类型和关键字的组合而已。后面的初始声明符列表的解析更复杂。如果有能力做完这些解析，恭喜你，成功的解析了声明语句。你会发现什么定义语句啦，调用语句啦，正妩媚的向你招手╮(╯▽╰)╭。</p>
<p>成功解析语法以后，我们会得到抽象语法树(AST: Abstract Syntax Tree)。以这段代码为例:</p>
<pre>
</pre>
<ol>
<li>int fun(int a, int b) { </li>
<li>    int c = 0; </li>
<li>    c = a + b; </li>
<li>    return c; </li>
<li>} </li>
</ol>
<p>它的语法树如下:</p>
<p><a href="http://s1.51cto.com/wyfs02/M01/9A/0C/wKiom1lQtcLgCF8rAABOrmYyg3A922.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOUEvMEMvd0tpb20xbFF0Y0xnQ0Y4ckFBQk9ybVl5ZzNBOTIyLmpwZw==.jpg"></a></p>
<p>语法树将字符串格式的源代码转化为树状的数据结构，更容易被计算机理解和处理。但它距离中间代码还有一定的距离。</p>
<p><strong>生成中间代码</strong></p>
<p>以 GCC 为例，生成中间代码可以分为三个步骤:</p>
<ol>
<li>语法树转高端 gimple</li>
<li>高端 gimple 转低端 gimple</li>
<li>低端 gimple 经过 cfa 转 ssa 再转中间代码</li>
</ol>
<p>简单的介绍一下每一步都做了什么。</p>
<p><strong>语法树转高端 gimple</strong></p>
<p>这一步主要是处理寄存器和栈，比如 c = a + b 并没有直接的汇编代码和它对应，一般来说需要把 a + b 的结果保存到寄存器中，然后再把寄存器赋值给  c。所以这一步如果用 C 语言来表示其实是:</p>
<pre>
</pre>
<ol>
<li>int temp = a + b; // temp 其实是寄存器 </li>
<li>c =  temp; </li>
</ol>
<p>另外，调用一个新的函数时会进入到函数自己的栈，建栈的操作也需要在 gimple 中声明。</p>
<p><strong>高端 gimple 转低端 gimple</strong></p>
<p>这一步主要是把变量定义，语句执行和返回语句区分存储。比如:</p>
<pre>
</pre>
<ol>
<li>int a = 1; </li>
<li>a++; </li>
<li>int b = 1; </li>
</ol>
<p>会被处理成:</p>
<pre>
</pre>
<ol>
<li>int a = 1; </li>
<li>int b = 1; </li>
<li>a++; </li>
</ol>
<p>这样做的好处是很容易计算一个函数到底需要多少栈空间。</p>
<p>此外，return 语句会被统一处理，放在函数的末尾，比如:</p>
<pre>
</pre>
<ol>
<li>if (1 &gt; 0) { </li>
<li>    return 1; </li>
<li>} </li>
<li>else { </li>
<li>    return 0; </li>
<li>} </li>
</ol>
<p>会被处理成:</p>
<pre>
</pre>
<ol>
<li>if (1 &gt; 0) { </li>
<li>    goto a; </li>
<li>} </li>
<li>else { </li>
<li>    goto b; </li>
<li>} </li>
<li>a: </li>
<li>    return 1; </li>
<li>b: </li>
<li>    return 0; </li>
</ol>
<p><strong>低端 gimple 经过 cfa 转 ssa 再转中间代码</strong></p>
<p>这一步主要是进行各种优化，添加版本号等，我不太了解，对于普通开发者来说也没有学习的必要。</p>
<p><strong>中间代码的意义</strong></p>
<p>其实中间代码可以被省略，抽象语法树可以直接转化为目标代码(汇编代码)。然而，不同的 CPU 的汇编语法并不一致，比如<br />
AT&amp;T与Intel汇编风格比较 这篇文章所提到的，Intel 架构和 AT&amp;T<br />
架构的汇编码中，源操作数和目标操作数位置恰好相反。Intel  架构下操作数和立即数没有前缀但 AT&amp;T<br />
有。因此一种比较高效的做法是先生成语言无关，CPU 也无关的中间代码，然后再生成对应各个 CPU  的汇编代码。</p>
<p>生成中间代码是非常重要的一步，一方面它和语言无关，也和 CPU<br />
与具体实现无关。可以理解为中间代码是一种非常抽象，又非常普适的代码。它客观中立的描述了代码要做的事情，如果用中文、英文来分别表示 C 和<br />
Java  的话，中间码某种意义上可以被理解为世界语。</p>
<p>另一方面，中间代码是编译器前端和后端的分界线。编译器前端负责把源码转换成中间代码，编译器后端负责把中间代码转换成汇编代码。</p>
<p>LLVM IR 是一种中间代码，它长成这样:</p>
<pre>
</pre>
<ol>
<li>define i32 @square_unsigned(i32 %a) { </li>
<li>  %1 = mul i32 %a, %a </li>
<li>  ret i32 %1 </li>
<li>} </li>
</ol>
<p><strong>生成目标代码</strong></p>
<p>目标代码也可以叫做汇编代码。由于中间代码已经非常接近于实际的汇编代码，它几乎可以直接被转化。主要的工作量在于兼容各种 CPU  以及填写模板。在最终生成的汇编代码中，不仅有汇编命令，也有一些对文件的说明。比如:</p>
<pre>
</pre>
<ol>
<li>  .file       "test.c"      # 文件名称 </li>
<li>    .global     m             # 全局变量 m </li>
<li>    .data                     # 数据段声明 </li>
<li>    .align      4             # 4 字节对齐 </li>
<li>    .type       m, @objc </li>
<li>    .size       m, 4 </li>
<li>m: </li>
<li>    .long       10            # m 的值是 10 </li>
<li>    .text </li>
<li>    .global     main </li>
<li>    .type       main, @function </li>
<li>main: </li>
<li>    pushl   %ebp </li>
<li>    movl    %esp,   %ebp </li>
<li>    ... </li>
</ol>
<p><strong>汇编</strong></p>
<p>汇编器会接收汇编代码，将它转换成二进制的机器码，生成目标文件(后缀是 .o)，机器码可以直接被 CPU  识别并执行。从目标代码可以猜出来，最终的目标文件(机器码)也是分段的，这主要有以下三个原因:</p>
<ol>
<li>分段可以将数据和代码区分开。其中代码只读，数据可写，方便权限管理，避免指令被改写，提高安全性。</li>
<li>现代 CPU 一般有自己的数据缓存和指令缓存，区分存储有助于提高缓存命中率。</li>
<li>当多个进程同时运行时，他们的指令可以被共享，这样能节省内存。</li>
</ol>
<p>段分离我们并不遥远，比如命令行中的 objcopy 可以自行添加自定义的段名，C 语言的 __attribute((section(段名)))__  可以把变量定义在某个特定名称的段中。</p>
<p>对于一个目标文件来说，文件的最开头(也叫作 ELF  头)记录了目标文件的基本信息，程序入口地址，以及段表的位置，相当于是对文件的整体描述。接下来的重点是段表，它记录了每个段的段名，长度，偏移量。比较常用的段有:</p>
<ul>
<li>.strtab 段: 字符串长度不定，分开存放浪费空间(因为需要内存对齐)，因此可以统一放到字符串表(也就是 .strtab  段)中进行管理。字符串之间用\0 分割，所以凡是引用字符串的地方用一个数字就可以代表。</li>
<li>.symtab:  表示符号表。符号表统一管理所有符号，比如变量名，函数名。符号表可以理解为一个表格，每行都有符号名(数字)、符号类型和符号值(存储地址)</li>
<li>.rel 段: 它表示一系列重定位表。这个表主要在链接时用到，下面会详细解释。</li>
</ul>
<p><strong>链接</strong></p>
<p>在一个目标文件中，不可能所有变量和函数都定义在文件内部。比如 strlen 函数就是一个被调用的外部函数，此时就需要把 main.o<br />
这个目标文件和包含了  strlen函数实现的目标文件链接起来。我们知道函数调用对应到汇编其实是 jump<br />
指令，后面写上被调用函数的地址，但在生成 main.o  的过程中，strlen() 函数的地址并不知道，所以只能先用 0<br />
来代替，直到最后链接时，才会修改成真实的地址。</p>
<p>链接器就是靠着重定位表来知道哪些地方需要被重定位的。每个可能存在重定位的段都会有对应的重定位表。在链接阶段，链接器会根据重定位表中，需要重定位的内容，去别的目标文件中找到地址并进行重定位。</p>
<p>有时候我们还会听到动态链接这个名词，它表示重定位发生在运行时而非编译后。动态链接可以节省内存，但也会带来加载的性能问题，这里不详细解释，感兴趣的读者可以阅读《程序员的自我修养》这本书。</p>
<p><strong>预处理</strong></p>
<p>最后简单描述一下预处理。预处理主要是处理一些宏定义，比如#define、#include、#if<br />
等。预处理的实现有很多种，有的编译器会在词法分析前先进行预处理，替换掉所有 # 开头的宏，而有的编译器则是在词法分析的过程中进行预处理。当分析到<br />
 #  开头的单词时才进行替换。虽然先预处理再词法分析比较符合直觉，但在实际使用中，GCC 使用的却是一边词法分析，一边预处理的方案。</p>
<p><strong>编译 VS 解释</strong></p>
<p>总结一下，对于 C<br />
语言来说，从源码到运行结果大致上需要经历编译、汇编和链接三个步骤。编译器接收源代码，输出目标代码(也就是汇编代码)，汇编器接收汇编代码，输出由机器码组成的目标文件(二进制格式，.o<br />
  后缀)，最后链接器将各个目标文件链接起来，执行重定位，最终生成可执行文件。</p>
<p>编译器以中间代码为界限，又可以分前端和后端。比如 clang 就是一个前端工具，而 LLVM 则负责后端处理。另一个知名工具<br />
GCC(GNU  Compile<br />
Collection)则是一个套装，包揽了前后端的所有任务。前端主要负责预处理、词法分析、语法分析，最终生成语言无关的中间代码。后端主要负责目标代码的生成和优化。</p>
<p>关于编译原理的基础知识虽然枯燥，但掌握这些知识有助于我们理解一些有用的，但不太容易理解的概念。接下来，我们简单看一下别的语言是如何运行的。</p>
<p><strong>Java</strong></p>
<p>在 Java 代码的执行过程中，可以简单分为编译和执行两步。Java 的编译器首先会把 .java 格式的源码编译成 .class  格式的字节码。字节码对应到 C 语言的编译体系中就是中间码，Java 虚拟机执行这些中间码得到最终结果。</p>
<p>回忆一下上文对中间码的解释，一方面它与语言无关，仅仅描述客观事实。另一方面它和目标代码的差距并不大，已经包括了对寄存器和栈的处理，仅仅是抽象了 CPU  架构而已，只要把它具体化成各个平台下的目标代码，就可以交给汇编器了。</p>
<p><strong>解释型语言</strong></p>
<p>一般来说我们也把解释型语言叫做脚本语言，比如 Python、Ruby、JavaScript  等等。这类语言的特点是，不需要编译，直接由解释器执行。换言之，运行流程变成了:</p>
<p>源代码 -&gt; 解释器 -&gt; 运行结果</p>
<p>需要注意的是，这里的解释器只是一个黑盒，它的实现方式可以是多种多样的。举个例子，它的实现可以非常类似于 Java<br />
的执行过程。解释器里面可以包含一个编译器和虚拟机，编译器把源码转化成 AST 或者字节码(中间代码)然后交给虚拟机执行，比如 Ruby 1.9<br />
 以后版本的官方实现就是这个思路。</p>
<p>至于虚拟机，它并不是什么黑科技，它的内部可以编译执行，也可以解释执行。如果是编译执行，那么它会把字节码编译成当前 CPU  下的机器码然后统一执行。如果是解释执行，它会逐条翻译字节码。</p>
<p>有意思的是，如果虚拟机是编译执行的，那么这套流程和 C 语言几乎一样，都满足下面这个流程:</p>
<p>源代码 -&gt; 中间代码 -&gt; 目标代码 -&gt; 运行结果</p>
<p><strong>下面是重点!!!</strong></p>
<p><strong>下面是重点!!!</strong></p>
<p><strong>下面是重点!!!</strong></p>
<p>因此，解释型语言和编译型语言的根本区别在于，对于用户来说，到底是直接从源码开始执行，还是从中间代码开始执行。以 C<br />
语言为例，所有的可执行程序都是二进制文件。而对于传统意义的 Python 或者<br />
JavaScript，用户并没有拿到中间代码，他们直接从源码开始执行。从这个角度来看， Java 不可能是解释型语言，虽然 Java<br />
虚拟机会解释字节码，但是对于用户来说，他们是从编译好的 .class 文件开始执行，而非源代码。</p>
<p>实际上，在 x86 这种复杂架构下，二进制的机器码也不能被硬件直接执行，CPU<br />
会把它翻译成更底层的指令。从这个角度来说，我们眼中的硬件其实也是一个虚拟机，执行了一些“抽象”指令，但我相信不会有人认为 C<br />
语言是解释型语言。因此，有没有虚拟机，虚拟机是不是解释执行，会不会生成中间代码，这些都不重要，重要的是如果从中间代码开始执行，而且 AST<br />
已经事先生成好，那就是编译型的语言。</p>
<p>如果更本质一点看问题，根本就不存在解释型语言或者编译型语言这种说法。已经有人证明，如果一门语言是可以解释的，必然可以开发出这门语言的编译器。反过来说，如果一门语言是可编译的，我只要把它的编译器放到解释器里，把编译推迟到运行时，这么语言就可以是解释型的。事实上，早有人开发出了<br />
  C 语言的解释器:</p>
<p>C 源代码 -&gt; C 语言解释器(运行时编译、汇编、链接) -&gt; 运行结果</p>
<p>我相信这一点很容易理解，规范和实现是两套分离的体系。我们平常说的 C<br />
语言的语法，实际上是一套规范。理论上来说每个人都可以写出自己的编译器来实现 C<br />
语言，只要你的编译器能够正确运行，最终的输出结果正确即可。而编译型和解释型说的其实是语言的实现方案，是提前编译以获得最大的性能提高，还是运行时去解析以获得灵活性，往往取决于语言的应用场景。所以说一门语言是编译型还是解释型的，这会非常可笑。一个标准怎么可能会有固定的实现呢?之所以给大家留下了<br />
  C 语言是编译型语言，Python 是解释型语言的印象，往往是因为这门语言的应用场景决定了它是主流实现是编译型还是解释型。</p>
<p><strong>自举</strong></p>
<p>不知道有没有人思考过，C 语言的编译器是如何实现的?实际上它还是用 C 语言实现的。这种自己能编译自己的神奇能力被称为自举(Bootstrap)。</p>
<p>乍一看，自举是不可能的。因为 C 语言编译器，比如 GCC，要想运行起来，必定需要 GCC 的编译器将它编译成二进制的机器码。然而 GCC  的编译器又如何编译呢……</p>
<p>解决问题的关键在于打破这个循环，我们可以先用一个比 C 语言低级的语言来实现一个 C<br />
语言编译器。这件事是可能做到的，因为这个低级语言必然会比 C  语言简单，比如我们可以直接用汇编代码来写 C<br />
语言的编译器。由于越低级的语言越简单，但表达能力越弱，所以用汇编来写可能太复杂。这种情况下我们可以先用一个比 C<br />
语言低级但比汇编高级的语言来实现 C<br />
语言的编译器，同时用汇编来实现这门语言的编译器。总之就是不断用低级语言来写高级语言的编译器，虽然语言越低级，它的表达能力越弱，但是它要解析的语言也在不断变简单，所以这件事是可以做到的。</p>
<p>有了低级语言写好的 C 语言编译器以后，这个编译器是二进制格式的。此时就可以删掉所有的低级语言，只留一个二进制格式的 C<br />
语言编译器，接下来我们就可以用  C 语言写编译器，再用这个二进制格式的编译器去编译 C 语言实现的 C 语言编译器了，于是完成了自举。</p>
<p>以上逻辑描述起来比较绕，但我想多读几遍应该可以理解。如果实在不理解也没关系，我们只要明白 C  语言可以自举是因为它可以编译成二进制机器码，只要用低级语言生成这个机器码，就不再需要低级语言了，因为机器码可以直接被 CPU 执行。</p>
<p>从这个角度来看，解释型语言是不可能自举的。以 Python 为例，自举要求它能用 Python 语言写出来 Python<br />
的解释器，然而这个解释器如何运行呢，最终还是需要一个解释器。而解释器体系下， Python<br />
都是从源码经过解释器执行，又不能留下什么可以直接被硬件执行的二进制形式的解释器文件，自然是没办法自举的。然而，就像前面说的，Python<br />
完全可以实现一个编译器，这种情况下它就是可以自举的。</p>
<p>所以一门语言能不能自举，主要取决于它的实现形式能否被编译并留下二进制格式的可执行文件。</p>
<p><strong>运行时</strong></p>
<p>本文的读者如果是使用 Objective-C 的 iOS 开发者，想必都有过在面试时被 runtime 支配的恐惧。然而，runtime<br />
并非是  Objective-C 的专利，绝大多数语言都有这个概念。所以有人说 Objective-C 具有动态性是因为它有<br />
runtime，这种说法并不准确，我觉得要把  Objective-C 的 runtime<br />
和一般意义的运行时库区分开，认识到它仅仅是运行时库的一个组成部分，同时还是要深入到方法调用的层面来谈。</p>
<p><strong>运行时库的基本概念</strong></p>
<p>以 C 语言为例，有非常多的操作最终都依赖于 glibc<br />
这个动态链接库。包括但不限于字符串处理(strlen、strcpy)、信号处理、socket、线程、IO、动态内存分屏(malloc)等等。这一点很好理解，如果回忆一下之前编译器的工作原理，我们会发现它仅仅是处理了语言的语法，比如变量定义，函数声明和调用等等。至于语言的功能，</p>
<p>比如内存管理，內建的类型，一些必要功能的实现等等。如果要对运行时库进行分类，大概有两类。一种是语言自身功能的实现，比如一些內建类型，内置的函数;另一种则是语言无关的基础功能，比如文件<br />
  IO，socket 等等。</p>
<p>由于每个程序都依赖于运行时库，这些库一般都是动态链接的，比如 C 语言的  (g)libc。这样一来，运行时库可以存储在操作系统中，节省内存占用空间和应用程序大小。</p>
<p>对于 Java 语言来说，它的垃圾回收功能，文件 IO 等都是在虚拟机中实现，并提供给 Java  层调用。从这个角度来看，虚拟机/解释器也可以被看做语言的运行时环境(库)。</p>
<p><strong>swift 运行时库</strong></p>
<p>经过这样的解释，相信 swift 的运行时库就很容易理解了。一方面，swift 是绝对的静态语言，另一方面，swift<br />
毫无疑问的带有自己的运行时库。举个最简单的例子，如果阅读 swift<br />
源码就会发现某些类型，比如字符串(String)，或者数组，再或者某些函数(print)都是用 swift 实现的，这些都是 swift<br />
运行时库的一部分。按理说，运行时库应该内置于操作系统中并且和应用程序动态链接，然而坑爹的 Swift 在本文写作之时依然没有稳定<br />
ABI，导致每个程序都必须自带运行时库，这也就是为什么目前 swift 开发的 app 普遍会增加几 Mb 包大小的原因。</p>
<p>说到 ABI，它其实就是一个编译后的 API。简单来说，API<br />
是描述了在应用程序级别，模块之间的调用约定。比如某个模块想要调用另一个模块的功能，就必须根据被调用模块提供的 API 来调用，因为 API<br />
中规定了方法名、参数和返回结果的类型。而当源码被编译成二进制文件后，它们之间的调用也存在一些规则和约定。</p>
<p>比如模块 A 有两个整数 a 和 b，它们的内存布局如下:</p>
<table>
<thead>
<tr>
<th>模块 A</th>
</tr>
</thead>
<tbody>
<tr>
<td>初始地址</td>
</tr>
<tr>
<td>a</td>
</tr>
<tr>
<td>b</td>
</tr>
</tbody>
</table>
<p>这时候别的模块调用 A 模块的 b 变量，可以通过初始地址加偏移量的方式进行。</p>
<p>如果后来模块 A 新增了一个整数 c，它的内存布局可能会变成:</p>
<table>
<thead>
<tr>
<th>模块 A</th>
</tr>
</thead>
<tbody>
<tr>
<td>初始地址</td>
</tr>
<tr>
<td>c</td>
</tr>
<tr>
<td>a</td>
</tr>
<tr>
<td>b</td>
</tr>
</tbody>
</table>
<p>如果调用方还是使用相同的偏移量，可以想见，这次拿到的就是变量 a 了。因此，每当模块 A 有更新，所有依赖于模块 A<br />
的模块都必须重新编译才能正确工作。如果这里的模块 A 是 swift<br />
的运行时库，它内置于操作系统并与其他模块(应用程序)动态链接会怎么样呢?结果就是每次更新系统后，所有的 app 都无法打开。显然这是无法接受的。</p>
<p>当然，ABI 稳定还包括其他的一些要求，比如调用和被调用者遵守相同的调用约定(参数和返回值如何传递)等。</p>
<p><strong>JavaScript 那些事</strong></p>
<p>我们继续刚才有关运行时的话题，先从 JavaScript 的运行时聊起，再介绍 JavaScript 的相关知识。</p>
<p><strong>JavaScript 是如何运行的</strong></p>
<p>JavaScript 和其他语言，无论是 C 语言，还是 Python 这样的脚本语言，最大的区别在于 JavaScript  的宿主环境比较奇怪，一般来说是浏览器。</p>
<p>无论是 C 还是 Python，他们都有一个编译器/解释器运行在操作系统上，直接把源码转换成机器码。而 JavaScript<br />
的解释器一般内置在浏览器中，比如 Chrome 就有一个 V8 引擎可以解析并执行 JavaScript 代码。因此 JavaScript<br />
的能力实际上会受到宿主环境的影响，有一些限制和加强。</p>
<p>首先来看看 DOM 操作，相关的 API 并没有定义在 ECMAScript 标准中，因此我们常用的 window.xxx 还有<br />
window.document.xxx 并非是 JavaScript 自带的功能，这通常是由宿主平台通过 C/C++ 等语言实现，然后提供给<br />
JavaScript 的接口。同样的，由于浏览器中的 JavaScript<br />
只是一个轻量的语言，没有必要读写操作系统的文件，因此浏览器引擎一般不会向  JavaScript 提供文件读写的运行时组件，它也就不具备 IO<br />
的能力。从这个角度来看，整个浏览器都可以看做 JavaScript  的虚拟机或者运行时环境。</p>
<p>因此，当我们换一个宿主环境，比如 Node.js，JavaScript 的能力就会发生变化。它不再具有 DOM<br />
API，但多了读写文件等能力。这时候，Node.js 就更像是一个标准的 JavaScript 解析器了。这也是为什么 Node.js 让<br />
JavaScript  可以编写后端应用的原因。</p>
<p><strong>JIT 优化</strong></p>
<p>解释执行效率低的主要原因之一在于，相同的语句被反复解释，因此优化的思路是动态的观察哪些代码是经常被调用的。对于那些被高频率调用的代码，可以用编译器把它编译成机器码并且缓存下来，下次执行的时候就不用重新解释，从而提升速度。这就是<br />
  JIT(Just-In-Time) 的技术原理。</p>
<p>但凡基于缓存的优化，一定会涉及到缓存命中率的问题。在 JavaScript  中，即使是同一段代码，在不同上下文中生成的机器码也不一定相同。比如这个函数:</p>
<pre>
</pre>
<ol>
<li>function add(a, b) { </li>
<li>    return a + b; </li>
<li>} </li>
</ol>
<p>如果这里的 a 和 b 都是整数，可以想见最终的代码一定是汇编中的 add<br />
命令。如果类似的加法运算调用了很多次，解释器可能会认为它值得被优化，于是编译了这段代码。但如果下一次调用的是 add("hello",<br />
"world")，之前的优化就无效了，因为字符串加法的实现和整数加法的实现完全不同。</p>
<p>于是优化后的代码(二进制格式)还得被还原成原先的形式(字符串格式)，这样的过程被称为去优化。反复的优化 -&gt; 去优化 -&gt; 优化 ……  非常耗时，大大降低了引入 JIT 带来的性能提升。</p>
<p>JIT 理论上给传统的 JavaScript 带了了 20-40  倍的性能提升，但由于上述去优化的存在，在实际运行的过程中远远达不到这个理论上的性能天花板。</p>
<p><strong>WebAssembly</strong></p>
<p>前文说过，JavaScript 实际上是由浏览器引擎负责解析并提供一些功能的。浏览器引擎可能是由 C++<br />
这样高效的语言实现的，那么为什么不用 C++  来写网页呢?实际上我认为从技术角度来说并不存在问题，直接下发 C++ 代码，然后交给 C++<br />
解释器去执行，再调用浏览器的 C++  组件，似乎更加符合直觉一些。</p>
<p>之所以选择 JavaScript 而不是 C++，除了主流浏览器目前都只支持 JavaScript 而不支持 C++<br />
这个历史原因以外，更重要的一点是一门语言的高性能和简单性不可兼得。JavaScript<br />
在运行速度方面做出了牺牲，但也具备了简单易开发的优点。作为通用编程语言，JavaScript 和 C++<br />
主要的性能差距就在于缺少类型标注，导致无法进行有效的提前编译。之前说过 JIT<br />
这种基于缓存去猜测类型的方式存在瓶颈，那么最精确的方式肯定还是直接加上类型标注，这样就可以直接编译了，代表性的作品有 Mozilla<br />
的Asm.js。</p>
<p>Asm.js 是 JavaScript 的一个子集，任何 JavaScript 解释器都可以解释它:</p>
<pre>
</pre>
<ol>
<li>function add(a, b) { </li>
<li>    a = a | 0  // 任何整数和自己做按位或运算的结果都是自己 </li>
<li>    b = b | 0  // 所以这个标记不改变运算结果，但是可以提示编译器 a、b 都是整数 </li>
<li>    return a + b | 0 </li>
<li>} </li>
</ol>
<p>如果有 Asm.js 特定的解释器，完全可以把它提前编译出来。即使没有也没关系，因为它完全是 JavaScript  语法的子集，普通的解释器也可以解释。</p>
<p>然而，回顾一下我们最初对解释器的定义: 解释器是一个黑盒，输入源码，输出运行结果。Asm.js<br />
其实是黑盒内部的一个优化，不同的黑盒(浏览器)无法共享这一优化。换句话说 Asm.js 写成的代码放到 Chrome 上面和普通的<br />
JavaScript  毫无区别。</p>
<p>于是，包括微软、谷歌和苹果在内的各大公司觉得，是时候搞个标准了，这个标准就是 WebAssembly  格式。它是介于中间代码和目标代码之间的一种二进制格式，借用WebAssembly 系列(四)WebAssembly 工作原理 一文的插图来表示:</p>
<p><a href="http://s2.51cto.com/wyfs02/M02/9A/0C/wKioL1lQtvWzU-X3AAA1AVm96q4097.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOUEvMEMvd0tpb0wxbFF0dld6VS1YM0FBQTFBVm05NnE0MDk3LmpwZw==.jpg"></a></p>
<p>通常从中间代码到机器码，需要经过平台具体化(转目标代码)和二进制化(汇编器把汇编代码变为二进制机器码)这两个步骤。而<br />
WebAssembly  首先完成了第二个步骤，即已经是二进制格式的，但只是一系列虚拟的通用指令，还需要转换到各个 CPU 架构上。这样一来，从<br />
 WebAssembly  到机器码其实是透明且统一的，各个浏览器厂商只需要考虑如何从中间代码转换 WebAssembly 就行了。</p>
<p>由于编译器的前端工具 Clang 可以把 C/C++ 转换成中间代码，因此理论上它们都可以用来开发网页。然而谁会这么这么做呢，放着简单快捷，现在又高效的  JavaScript 不写，非要去啃 C++?</p>
<p><strong>跨语言那些事儿</strong></p>
<p>C++ 写网页这个脑洞虽然比较大，但它启发我思考一个问题:“对于一个常见的可以由某个语言完成的任务(比如 JavaScript  写网页)，能不能换一个语言来实现(比如 C++)，如果不能，制约因素在哪里”。</p>
<p>由于绝大多数主流语言都是图灵完备的，也就是说一切可计算的问题，在这些语言层面都是等价的，都可以计算。那么制约语言能力的因素也就只剩下了运行时的环境是否提供了相应的功能。比如前文解释过的，虽然浏览器中的<br />
  JavaScript 不能读写文件，不能实现一个服务器，但这是浏览器(即运行时环境)不行，不是 JavaScript<br />
不行，只要把运行环境换成 Node.js  就行了。</p>
<p><strong>直接语法转换</strong></p>
<p>大部分读者应该接触过简单的逆向工程。比如编译后的 .o 目标文件和 .class<br />
字节码都可以反编译成源代码，这种从中间代码倒推回源代码的技术也被叫做反编译(decompile)，反编译器的工作流程基本上是编译器的倒序，只不过完美的反编译一般来说比较困难，这取决于中间代码的实现。像<br />
  Java 字节码这样的中间代码，由于信息比较全，所以反编译就相对容易、准确一些。C 代码在生成中间代码时丢失了很多信息，因此就几乎不可能<br />
100%  准确的倒推回去，感兴趣的读者可以参考一下知名的反编译工具Hex-Rays 的一篇博客。</p>
<p>前文说过，编译器前端可以对多种语言进行词法分析和语法分析，并且生成一套语言无关的中间代码，因此理论上来说，如果某个编译器前端工具支持两个语言 A 和 B  的解析，那么 A 和 B 是可以互相转换的，流程如下:</p>
<p>A 源码 &lt;--&gt; 语言无关的中间代码 &lt;--&gt; B 源码</p>
<p>其中从源码转换到中间代码需要使用编译器，从中间代码转换到源码则使用反编译器。</p>
<p>但在实际情况中，事情会略复杂一些，这是因为中间代码虽然是一套语言无关、CPU<br />
也无关的指令集，但不代表不同语言生成的中间代码就可以通用。比如中间代码共有  1、2、3、……、6 这六个指令。A<br />
语言生成的中间代码仅仅是所有指令的一个子集，比如是 1-5 这 5 个指令;B  语言生成的中间代码可能是所有指令的另一个子集，比如<br />
2-6。这时候我们说的 B 语言的反编译器，实际上是从 2-6 的指令子集推导出 B 语言源码，它对指令 1  可能无能为力。</p>
<p>以 GCC 的中间代码 RTL: Register Transfer Language 为例，官方文档 在对 RTL 的解释中，就明确的把 RTL  树分为了通用的、C/C++ 特有的、Java 特有的等几个部分。</p>
<p><a href="http://s3.51cto.com/wyfs02/M02/9A/0C/wKioL1lQtwTCOhg1AACXPzp3Fyo665.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOUEvMEMvd0tpb0wxbFF0d1RDT2hnMUFBQ1hQenAzRnlvNjY1LmpwZw==.jpg"></a></p>
<p>具体来说，我们知道 Java 并不能直接访问内存地址，这一点和浏览器上的 JavaScript<br />
不能读写文件很类似，都是因为它们的运行环境(虚拟机)具备这种能力，但没有在语言层面提供。因此，含有指针四则运算的 C 代码无法直接被转换成<br />
Java 代码，因为  Java 字节码层面并没有定义这样的抽象，一种简单的方案是申请一个超大的数组，然后自己模拟内存地址。</p>
<p>所以，即使编译器前端同时支持两种语言的解析，要想进行转换，还必须处理两种语言在中间代码层面的一些小差异，实际流程应该是:</p>
<p>A 源码 &lt;--&gt; 中间代码子集(A) &lt;--适配器--&gt; 中间代码子集(B) &lt;--&gt; B 源码</p>
<p>这个思路已经不仅仅停留在理论上了，比如 Github 上有一个库: emscripten 就实现了将任何 Clang 支持的语言(比如 C/C++  等)转换成 JavaScript，再比如 lljvm实现了 C 到 Java 字节码的转换。</p>
<p>然而前文已经解释过，实现单纯语法的转换意义并不大。一方面，对于图灵完备的语言来说，换一种表示方法(语言)去解决相同的问题并没有意义。另一方面，语言的真正功能绝不仅仅是语法本身，而在于它的运行时环境提供了什么样的功能。比如<br />
  Objective-C 的 Foundation 库提供了字典类型 NSDictionary，它如果直接转换成 C<br />
语言，将是一个找不到的符号。因为 C<br />
语言的运行时环境根本就不提供对这种数据结构的支持。因此凡是在语言层面进行强制转换的，要么利用反编译器拿到一堆格式正确但无法运行的代码，要么就自行解析语法树并为转换后的语言添加对应的能力，来实现转换前语言的功能。</p>
<p><a href="http://s3.51cto.com/wyfs02/M00/9A/0C/wKioL1lQtxagjJPiAABirCeQ5BQ932.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOUEvMEMvd0tpb0wxbFF0eGFnakpQaUFBQmlyQ2VRNUJROTMyLmpwZw==.jpg"></a></p>
<p>比如图中就是一个 C 语言转换 Java 的工具，为了实现 C 语言中的字符串申请和释放内存，这个工具不得不自己实现了  com.mtsystems.coot.String8 类。这样巨大的成本，显然不够普适，应用场景相对有限。</p>
<p>总之，直接的语法转换是一个美好的想法，但实现起来难度大，收益有限，通常是为了移植已经用某个语言写好的框架，或者开个脑洞用于学习，但实际应用场景并不多。</p>
<p><strong>胶水语言 Python</strong></p>
<p>Python 一个很强大的特点是胶水语言，可以把 Python 理解为各种语言的粘合剂。对于 Python 可以处理的逻辑，用<br />
Python  代码即可完成。如果追求极致的性能或者调用已经实现的功能，也可以让 Python 调用已经由别的语言实现的模块，以 Python 和<br />
 C  语言的交互解释一下。</p>
<p>首先，如果是 C 语言要执行 Python 代码，显然需要一个 Python 的解释器。由于在 Mac OS X 系统上，Python  解释器是一个动态链接库，所以只要导入一下头文件即可，下面这段代码可以成功输出 “Hello Python!!!”:</p>
<pre>
</pre>
<ol>
<li>#include &lt;stdio.h&gt; </li>
<li>#import &lt;Python/Python.h&gt; </li>
<li> </li>
<li>int main(int argc, const char * argv[]) { </li>
<li>    Py_SetProgramName(argv[0]); </li>
<li>    Py_Initialize(); </li>
<li>    PyRun_SimpleString("print 'Hello Python!!!'\n"); </li>
<li>    Py_Finalize(); </li>
<li>    return 0; </li>
<li>} </li>
</ol>
<p>如果是在 iOS 应用里，由于 iOS 系统没有对应的动态库，所以需要把 Python<br />
的解释器打包成一个静态库并且链接到应用中，网上已经有人做好了:  python-for-iphone，这就是为什么我们看到一些教育类的应用模拟了<br />
 Python 解释器，允许用户编写 Python 代码并得到输出。</p>
<p>Python 调用 Objective-C/C 也不复杂，只需要在 C 代码中指定要暴露的模块 A 和要暴露的方法 a，然后 Python  就可以直接调用了:</p>
<pre>
</pre>
<ol>
<li>import A </li>
<li>A.a() </li>
</ol>
<p>详细的教程可以看这里: 如何实现 C/C++ 与 Python 的通信?</p>
<p>有时候，如果能把自己熟悉的语言应用到一个陌生的领域，无疑会大大降低上手的难度。以 iOS 开发为例，开发者的日常其实是利用<br />
Objective-C  语法来描述一些逻辑，最终利用 UIKit 等框架完成和应用的交互。 一种很自然而然的想法是，能不能用 Python<br />
来实现逻辑，并且调用 Objective-C  的接口，比如 UIKit、Foundation 等。实际上前者是完全可以实现的，但是<br />
Python 调用 Objective-C 远比调用 C  语言要复杂得多。</p>
<p>一方面从之前的分析中也能看出，并不是所有的源码编译成目标文件都可以被 Python 引用;另一方面，最重要的是 Objective-C<br />
方法调用的特性。我们知道方法调用实际上会被编译成 msg_Send 并交给 runtime 处理，最终找到函数指针并调用。这里<br />
Objective-C 的  runtime 其实是一个用 C 语言实现动态链接库，它可以理解为 Objective-C<br />
运行时环境的一部分。换句话说，没有 runtime  这个库，包含方法调用的 Objective-C 代码是不可能运行起来的，因为<br />
msg_Send 这个符号无法被重定向，运行时将找不到 msg_Send  函数的地址。就连原生的 Objective-C<br />
代码都需要依赖运行时，想让 Python 直接调用某个 Objective-C  编译出来的库就更不可能了。</p>
<p>想用 Python 写开发 iOS 应用是有可能的，比如: PyObjc，但最终还是要依赖 Runtime。大概的思路是首先用<br />
Python 拿到  runtime 这个库，然后通过这个库去和 runtime 交互，进而具备了调用 Objective-C<br />
和各种框架的能力。比如我要实现 Python 中的  UIView 这个类，代码会变成这样:</p>
<pre>
</pre>
<ol>
<li>import objc </li>
<li> </li>
<li># 这个 objc 是动态加载 libobjc.dylib 得到的 </li>
<li># Python 会对 objc 做一些封装，提供调用 runtime 的能力 </li>
<li># 实际的工作还是交给 libobjc.dylib 完成 </li>
<li> </li>
<li>class UIView: </li>
<li>    def __init__(self, param): </li>
<li>        objc.msgSend("UIView", "init", param) </li>
</ol>
<p>这么做的性价比并不高，如果和 JSPatch 相比，JSPatch 使用了内置的 JavaScriptCore 作为 JavaScript<br />
 的解析器，而  PyObjc 就得自己带一个 libPython.a 解释器。此外，由于 iOS 系统的沙盒限制，非越狱机器并不能拿到<br />
libobjc  库，所以这个工具只能在越狱手机上使用。</p>
<p><strong>OCS</strong></p>
<p>既然说到了 JSPatch 这一类动态化的 iOS 开发工具，我就斗胆猜测一下腾讯 OCS 的实现原理，目前介绍 OCS<br />
的文章寥寥无几，由于苹果公司的要求，原文已经被删除，从新浪博客上摘录了一份: OCS ——史上最疯狂的 iOS<br />
动态化方案。如果用一句话来概述，那么就是 OCS  是一个 Objective-C 解释器。</p>
<p>首先，OCS 基于 clang 对下发的 Objective-C 代码做词法、语法分析，生成 AST<br />
然后转化成自定义的一套中间码(OSScript)。当然，原生的 Objective-C<br />
可以运行，绝不仅仅是编译器的功劳。就像之前反复强调的那样，运行时环境也必不可少，比如负责 GCD 的 libdispatch<br />
库，还有内存管理，多线程等等功能。这些功能原来都由系统的动态库实现，但现在必须由解释器实现，所以 OCS<br />
的做法是开发了一套自己的虚拟机去解释执行中间码。这个运行原理就和 JVM 非常类似了。</p>
<p>当然，最终还是要和 Objective-C 的 Runtime 打交道，这样才能调用 UIKit  等框架。由于对虚拟机的实现原理并不清楚，这里就不敢多讲了，希望在学习完 JVM 以后再做分享。</p>
<p><strong>参考资料</strong></p>
<ol>
<li>AT&amp;T与Intel汇编风格比较</li>
<li>glibc</li>
<li>WebAssembly 系列(一)生动形象地介绍 WebAssembly</li>
<li>Decompilers and beyond</li>
<li>python-for-iphone</li>
<li>如何实现 C/C++ 与 Python 的通信?</li>
<li>WebAssembly 系列(四)WebAssembly 工作原理</li>
<li>扯淡：大白话聊聊编译那点事儿</li>
<li>rubicon-objc</li>
<li>OCS ——史上最疯狂的 iOS 动态化方案</li>
<li>虚拟机随谈(一)：解释器，树遍历解释器，基于栈与基于寄存器，大杂烩</li>
<li>JavaScript的功能是不是都是靠C或者C++这种编译语言提供的?</li>
<li>计算机编程语言必须能够自举吗?</li>
<li>如何评论浏览器最新的 WebAssembly 字节码技术?</li>
<li>Objective-C Runtime —— From Build To Did Launch</li>
<li>10 GENERIC</li>
<li>写个编译器，把C++代码编译到JVM的字节码可不可行? </li>
</ol>
<p>作者：bestswifter</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-13 06:56:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8f%e8%a7%88%e5%99%a8/" title="浏览器">浏览器</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/objective-c/" title="objective c">objective c</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>大前端开发者需要了解的基础编译原理和语言知识的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7ak2z.html" rel="bookmark">2017年6月前端开发者干货大合集</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				每个月的前端开发者干货素材大合集,相对而言更加专注于为网页设计师和前端开发者搜集相关的工具和素材,这次的大合集当中包含一款颇为有趣的屏幕录像软件,几款适用范围较广的基于Material Design的框架,还有一些性能测试库也非常好用.这些前端工具与素材功能各不相同,总会有一两款是你感兴趣,甚至正好想要的~ Kap Kap 是一款设计精巧的macOS 屏幕录像软件,它是基于Web技术来搭建的开源APP.这款应用中最令人着迷的是它的即时转码输出功能.Kap 是帮你记录APP的绝佳工具. Sizzy			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLgq7aM.html" rel="bookmark">一张图掌握移动Web前端所有技术（大前端、工程化、预编译、自动化）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你要的移动web前端都在这里! 大前端方向:移动Web前端.Native客户端.Node.js. 大前端框架:React.Vue.js.Koa 跨终端技术:HTML 5.CSS 3.JavaScript 跨平台框架:React Native.Cordova 前端工程化:Grunt.Gulp.Webpack 前端预编译:Babel.Sass.Less 自动化测试:Jasmine.Mocha.Karma 一图在手,应有尽有!			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zG32Oz.html" rel="bookmark">【译】前端开发者的基本要求</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接:http://rmurphey.com/blog/2012/04/12/a-baseline-for-front-end-developers/ 本文在github上的链接:https://github.com/chyingp/blog/issues/1 备注:第一次翻译技术文章,标题都纠结了好久不知道肿么翻译,如发现翻译不当之处,可点击github链接提交评论,thx- 前几天我为一个项目写README文档,我希望其他开发者能够看到这个项目,并从中学到一些东西.突然我意识到,若放在几			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrYa1M.html" rel="bookmark">微信小程序会让前端开发者失业</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这两天微信小程序的内测,被这个事件刷屏,让很多前端开发者感觉以后就是铁饭碗了.而我作为一个将近10年的前端开发者,恰恰看到了事情的另外一面,前端开发开发者的饭碗会被后端开发同学,设计师,产品经理以及其他想学习开发小程序的人占领,大部分低水平前端开发者面临失业.我为什么这样说,下面我来给大伙分析下原因: 我们想想在没有微信小程序的时候,前后端怎么来分工: 前端工程师 开发基础组件,页面的静态样式,交互 后端工程师 开发业务逻辑和把数据套在前端写好的静态页面上. 最不擅长是写页面布局,页面交互,开发			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYXwkeb.html" rel="bookmark">专访阿里巴巴淘宝事业部前端开发专家子宽：界面动态化技术是大前端领域的新方向</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				杭州·云栖大会将于2016年10月13-16日在云栖小镇举办,在这场标签为互联网.创新.创业的云计算盛宴上,众多行业精英都将在这几天里分享超过450个演讲主题. 为了帮助大家进一步了解这场全球前言技术共振盛会的内容,采访了各个论坛的大咖,以飨读者. 以下为正文:                                                        子宽,阿里巴巴前端技术专家 ,Weex团队成员,曾负责阿里无线事业部基础业务前端团队,目前在Weex团队中负责开源和部分工具链			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxoEgGb.html" rel="bookmark">10大iOS开发者最喜爱的类库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				该10大iOS开发者最喜爱的库由&quot;iOS辅导团队&quot;成员Marcelo Fabri组织投票选举而得,参与者包括开发者团队,iOS辅导团队以及行业嘉宾.每个团队都要根据以下规则选出五个最好的库:1)不能投自己写的库:2)排除大的架构,比如游戏类架构:3)排除不在设备上运行的库,例如CocoaPods或者Rack::CoreData也排除在外. 最终评选出了如下10大iOS开发者最喜爱的库: 1)SSToolkit Sam Soffes简直就是一个Objective-C天才,SSToolki			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZWmqz.html" rel="bookmark">前端开发者，2017 年你应该学习什么</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在当今的快节奏生态中,我们都倾向于花时间尝试最新的发明,然后在网络上进行激烈的辩论. 这里,我并不是说我们不能这样做.但我们的确应该把脚步放慢一些,并认真了解那些不会有很大变化的事情.这样不仅会提升我们的工作质量和我们所创造的价值 -- 还将切实地帮助我们更快理解这些新的工具. 本文融合了我的个人经历以及对新一年的希冀.正如我想热切表达自己想法一样,我也期待能在下方的评论表单中看到你的建议. 学习如何写出可读性高的代码 我们多数的工作并不是编写新代码,而是维护已有代码.这意味着你最终阅读代码的时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zG1AjoM.html" rel="bookmark">站长蜕变记：万能的网站前端开发者</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 前面已经发布过了站长蜕变记的首篇文章:基础要素的构成.里面所讲述的都是准备阶段的事情,如果你没有看过而且也是刚刚入门的话,那么建议略读一下,可能会对下面的讲述在理解上面有所帮助.本篇的标题是:万能的网站前端开发者.是站长完美蜕变的第二阶段,也是非常重要的阶段.是的,这篇文章告诉你的就是,想要蜕变,你就必须成为一名优秀的网站前端开发者.下面,我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/4MYXR9b.html" rel="bookmark">求各位大神帮忙做一下编译原理程序设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 求各位大神帮忙做一下编译原理程序设计 1．设计词法分析器 设计各单词的状态转换图,并为不同的单词设计种别码.将词法分析器设计成供语 法分析器调用的子程序.功能包括:具备预处理功能.将不翻译的注释等符号先滤掉,只保留要翻译的符号串,即要求设计一个供词法分析调用的预处理子程序:能够拼出语言中的各个单词:http://ask.csdn.net/#将拼出的标识符填入符号表:返回(种别码, 属性值).2．目标代码生成器c. 能完成指定寄存器个数的情况下将一中间代码程序段翻译成汇编语言目标代码(汇			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrE4bK.html" rel="bookmark" class="title">&period;NET和SQL Server中&OpenCurlyDoubleQuote;空值&rdquo;辨析</a>
					<div>
						server 初学数据库编程我们可能会有一些对&quot;空值&quot;的疑问,比如通过编程新建的一个表中所有数据皆显示为&lt;NULL&gt;,手动添加并删除文字后又变成了空白:一个字符串类型的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXVq4b.html" rel="bookmark" class="title">photoshop荷花作品的后期处理方法</a>
					<div>
						文/ 出处:网易 数码相机拍出来的荷花还要经过一番处理才能还原出荷花原本艳丽的色彩, 下面就告诉大家一种图片处理的方法. 首先将原图片缩小到合适的大小 一般来说在网上发布的图片长边不要超过660DPI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7DLdb.html" rel="bookmark" class="title">被遗忘的&OpenCurlyDoubleQuote;活化石&rdquo;：BBS没落中求生</a>
					<div>
						BBS,消失的江湖? 恐龙跟不上蜜蜂的脚步 如果让媒体和行业人士评价2012年比较失意的IT企业,估计很少有人会想起天涯.猫扑这样的网站--不是它们活得很好,而是在微博和微信夺人眼球的今天,传统的BB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyBmEp.html" rel="bookmark" class="title">结构和类</a>
					<div>
						在C++中,结构和类很相似,结构的成员默认为公共类型,而类的成员默认为私有类型.而在C#中,它们是完全不同的类型: 1:类型: 结构是值类型,在堆栈上分配地址,所以结构之间的赋值可以创建新的结构:而类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE837b.html" rel="bookmark" class="title">用Oracle10g列值掩码技术隐藏敏感数据</a>
					<div>
						Oracle的虚拟私有数据库特性(也称作细颗粒度存取控制)对诸如SELECT等数据管理语言DML语句提供行级安全性检查.PL/SQL策略函数和某个数据表相关联,这个函数可以检查当前用户的上下文背景并添 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm70qlb.html" rel="bookmark" class="title">XP系统快速启动栏的图标不见了怎么办？</a>
					<div>
						  XP系统快速启动栏的图标不见了怎么办?今天小编就给大家介绍一下具体的解决方法. 方法如下: 第一步.在任务栏的空白处单击鼠标右键,在弹出的右键菜单中选择&quot;属性&quot;命令,打开&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkR8Ob.html" rel="bookmark" class="title">上网本可以用U盘装Win7吗</a>
					<div>
						  上网本的用户因为没有DVD光驱无法安装Windows 7系统而郁闷.其实,你大可不必沮丧,因为不用DVD光驱我们照样可以安装Windows 7系统,仅仅需要一个4GB大小的U盘,经过测试,使用U盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o8Pkb.html" rel="bookmark" class="title">酷狗音乐盒个人中心头像如何更换</a>
					<div>
						  1.进入到酷狗音乐盒界面,按要求登录酷狗个人中心. 2.点击头像右侧的浏览按钮,选择一张图片,并点击上传按钮. 3.系统会提示我们头像保存成功了,我们可以看到已经更换好的头像.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWq1mb.html" rel="bookmark" class="title">隐藏导航栏之后支持手势退回上一个控制器</a>
					<div>
						隐藏导航栏之后支持手势退回上一个控制器     说明 1. 我们在隐藏导航栏之后,手势退回就会消失,但可以通过一些手段来继续支持手势 2. 在对导航栏控制器的根控制器使用的时候要特别注意,会导致bug ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwP45M.html" rel="bookmark" class="title">jQuery&plus;ajax中getJSON&lpar;&rpar; 用法实例&lowbar;jquery</a>
					<div>
						实例 从 test.js 载入 JSON 数据并显示 JSON 数据中一个 name 字段数据: 复制代码 代码如下: $.getJSON(&quot;test.js&quot;, function( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjjGBp.html" rel="bookmark" class="title">谁有基于用户的推荐系统或者协同过滤的算法和代码分析啊</a>
					<div>
						问题描述 求个大数据的大神给个基于用户的推荐系统或者协同过滤的算法和代码分析啊我有部分代码但是不知道怎么在Eclipse上实现求解答啊1.publicclassAggregateAndRecommen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn78Arz.html" rel="bookmark" class="title">IFA有哪些值得注意的新产品？</a>
					<div>
						前天,柏林国际电子消费品及家电展览会在德国柏林正式开幕.该会全称为Internationale Funkausstellung Berlin,简称IFA,为期六天.IFA是欧洲最大的电子消费品展览会, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxo4Ojb.html" rel="bookmark" class="title">《数值分析（原书第2版）》&mdash;&mdash; 第2章　方　程　组</a>
					<div>
						第2章 方 程 组 物理定律控制着所有的工程结构,从摩天大楼与桥梁,到跳水板以及医疗设备.静态或者动态的受力使得物体变形或者扭曲.扭曲的数学模型是结构工程师工作桌上的基本工具.结构在受力时可以扭曲的度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YqOdM.html" rel="bookmark" class="title">Mybatid关联表查询</a>
					<div>
						Mybatid关联表查询 一.一对一关联  1.1.提出需求 根据班级id查询班级信息(带老师的信息) 1.2.创建表和数据 创建一张教师表和班级表,这里我们假设一个老师只负责教一个班,那么老师和班级 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWl8yp.html" rel="bookmark" class="title">堆栈-怎样判断栈溢出和栈的大小？</a>
					<div>
						问题描述 怎样判断栈溢出和栈的大小? 昨天面试时被问到,怎样判断栈溢出这个问题,一时间没有了思路,请各位大神帮忙解答一下,提前谢谢了! 解决方案 用一个变量记录栈大小 解决方案二: 重新设置堆栈指针指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3arEz.html" rel="bookmark" class="title">程序员必读书单</a>
					<div>
						关于 本文把程序员所需掌握的关键知识总结为三大类19个关键概念,然后给出了掌握每个关键概念所需的入门书籍,必读书籍,以及延伸阅读.旨在成为最好最全面的程序员必读书单. 前言 Reading makes ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrlL8M.html" rel="bookmark" class="title">浅谈网站域名转出过程中的一些感受</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 每个人都有权利选择提供服务较好,管理较为便利的网络服务提供商.近来,有不少国内代理或者直接用户都逐渐将域名转向国外,包括我自己和身边的一些朋友,一方面是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1Kn4z.html" rel="bookmark" class="title">Informatica通过自动数据治理与合规实践 向企业交付可信及安全数据</a>
					<div>
						Informatica数据治理与合规解决方案是业界首款智能的单一解决方案,使业务.技术和安全部门都参与到针对所有企业数据的治理活动中. • 能在整个企业范围内更加方便地访问.理解和使用数据,从而对企业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94RGgb.html" rel="bookmark" class="title">家庭影院成上半年投诉热点</a>
					<div>
						(记者张璐)昨日,中消协公布了今年上半年全国消协组织受理投诉情况分析.数据显示,家庭影院.厨房电器等商品投诉量猛增. 投诉量同比上升幅度相对较大的商品是家庭影院.厨房电器及相关设备和汽车.上半年,家庭 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLv9Np.html" rel="bookmark" class="title">《精解 Windows 10》&mdash;&mdash;2&period;3　平板模式</a>
					<div>
						2.3 平板模式 在Windows 10操作系统中,用户可使用的操作环境有两种,分别是桌面模式和平板模式.桌面模式也就是自Windows 95操作系统开始一直使用至今的桌面环境,应用程序图标放置于桌面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB5ovb.html" rel="bookmark" class="title">ASP&period;NET开源博客QBlog模板皮肤制作教程索引贴</a>
					<div>
						最近几天花了点时间,制作了一下教程,写了几篇 开源博客 秋色园 QBlog 模板皮肤制作文章,这里给出一个索引: PS:同时 秋色园 也增加了四套皮肤,目前共有8套皮肤.   1:ASP.NET开源博 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZlNdp.html" rel="bookmark" class="title">IPO重启第二单依然花落中小板万马电缆获得核准</a>
					<div>
						IPO重启后的第二单依然花落中小板. 浙江万马电缆股份有限公司首次公开发行A股的申请获得中国证监会核准.据万马电缆今日刊登的招股意向书,公司拟发行不超过5000万股A股,占发行后总股本比例的25%,发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Jlr3z.html" rel="bookmark" class="title">关于DevComponents&period;AdvTree 的问题</a>
					<div>
						问题描述 求教,有一个DevComponents.AdvTree,在添加节点的时候设置了勾选框可见,我现在想像WINFORM自带的tree那样,只在点击节点文字时触发AfterNodeSelect之类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2gKqz.html" rel="bookmark" class="title">Ajax的小贴士使用小结&lowbar;AJAX相关</a>
					<div>
						在使用Ajax过程中,有时候总会遇到一些难题,浏览器兼容.编码.IE下的特殊处理等等,偶尔会搞的人头昏脑胀哭笑不得,这里列一些小贴士,或许有些用.  使用Javascript库         Aja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8GOWp.html" rel="bookmark" class="title">Python抓取京东图书评论数据&lowbar;python</a>
					<div>
						 京东图书评论有非常丰富的信息,这里面就包含了购买日期.书名.作者.好评.中评.差评等等.以购买日期为例,使用Python + Mysql的搭配进行实现,程序不大,才100行.相关的解释我都在程序里加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zen290b.html" rel="bookmark" class="title">CDN的实现原理</a>
					<div>
						在描述CDN的实现原理,让我们先看传统的未加缓存服务的访问过程,以便了解CDN缓存访问方式与未加缓存访问方式的差别: 用户提交域名→浏览器对域名进行解释→得到目的主机的IP地址→根据IP地址访问发出请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Dk7ab.html" rel="bookmark" class="title">《SOA与REST：用REST构建企业级SOA解决方案》&mdash;第1章1&period;2节推荐阅读</a>
					<div>
						1.2 推荐阅读为了进一步确保清晰理解后续章节中使用和引用的关键术语,你可以访问www.soaglossary.com网站,它提供了针对本系列书的在线主词汇表. 详细阐述本标题涵盖的关键主题的系列书籍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdQ1Bb.html" rel="bookmark" class="title">农业大数据民企敢为先</a>
					<div>
						&quot;现阶段农业的主要矛盾仍是供需问题,农业供给侧改革将是今后一个时期农业农村发展的重头戏.希望民营企业通过充分运用大数据技术,找到农业供给侧和需求侧的错位之处,发现市场空白.&quot; &q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrv481M.html" rel="bookmark" class="title">MapR试图将SQL-on-Hadoop推向新水平</a>
					<div>
						MapR今天更新了其Hadoop发行版,新增了Apache Drill 0.5,以减少繁重的数据工程工作. Drill是开源分布式ANSI查询引擎,主要用于自助服务数据分析.这是谷歌的Dremel系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Ywanp.html" rel="bookmark" class="title">今年，全球产业互联网发展提速</a>
					<div>
						近日,中国信息通信研究院发布了&lt;互联网发展趋势报告(2017)&gt;,报告认为,2017年全球产业互联网发展将提速. 万物互联时代全面开启 全球互联网连接增长步入动力转换阶段.全球互联网正从& ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.065 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
